# Multi-Processing Module Common Directives

This file documents directives that are implemented by more than one multi-processing module (MPM).

## Directives

- ConnectionStatus
- CoreDumpDirectory
- Group
- PidFile
- Listen
- ListenBacklog
- LockFile
- MaxClients
- MaxRequestsPerChild
- MaxSpareThreads
- MaxThreadsPerChild
- MinSpareThreads
- NumServers
- ScoreBoardFile
- SendBufferSize
- StartServers
- StartThreads
- ThreadsPerChild
- User

## ConnectionStatus directive

Syntax: ConnectionStatus on|off
Default: `ConnectionStatus on`
Context: server config
Status: MPM
Module: perchild

Whether or not to maintain status information on current connections. If this is off then mod_status will not work properly.

## CoreDumpDirectory directive

Syntax: CoreDumpDirectory directory
Default: the same location as ServerRoot
Context: server config
Status: MPM
Module: threaded, perchild, prefork, mpm_winnt

This controls the directory to which Apache attempts to switch before dumping core. The default is in the ServerRoot directory, however since this should not be writable by the user the server runs as, core dumps won't normally get written. If you want a core dump for debugging, you can use this directive to place it in a different location.

## Group directive

Syntax: Group unix-group
Default: `Group #-1`
Context: server config, virtual host
Status: MPM
Module: threaded, perchild, prefork

The Group directive sets the group under which the server will answer requests. In order to use this directive, the stand-alone server must be run initially as root. Unix-group is one of:

A group name
  Refers to the given group by name.
# followed by a group number.
  Refers to a group by its number.

It is recommended that you set up a new group specifically for running the server. Some admins use user `nobody`, but this is not always possible or desirable.

Note: if you start the server as a non-root user, it will fail to change to the specified group, and will instead continue to run as the group of the original user.

Special note: Use of this directive in <VirtualHost> requires a properly configured suEXEC wrapper. When used inside a <VirtualHost> in this manner, only the group that CGIs are run as is affected. Non-CGI requests are still processed as the group specified in the main Group directive.

SECURITY: See User for a discussion of the security considerations.

## PidFile directive

Syntax: PidFile filename
Default: `PidFile logs/httpd.pid`
Context: server config
Status: MPM
Module: threaded, perchild, prefork, mpm_winnt

The PidFile directive sets the file to which the server records the process id of the daemon. If the filename does not begin with a slash (/) then it is assumed to be relative to the ServerRoot.

It is often useful to be able to send the server a signal, so that it closes and then reopens its ErrorLog and TransferLog, and re-reads its configuration files. This is done by sending a SIGHUP (kill -1) signal to the process id listed in the PidFile.

The PidFile is subject to the same warnings about log file placement and security.

## Listen directive

Syntax: Listen [IP-address:]port number
Context: server config
Status: MPM
Module: threaded, perchild, prefork, mpm_winnt

The Listen directive instructs Apache to listen to only specific IP addresses or ports; by default it responds to requests on all IP interfaces, but only on the port given by the `Port` directive.

The Listen directive tells the server to accept incoming requests on the specified port or address-and-port combination. If only a port number is specified, the server listens to the given port on all interfaces, instead of the port given by the `Port` directive. If an IP address is given as well as a port, the server will listen on the given port and interface.

Note that you may still require a `Port` directive so that URLs that Apache generates that point to your server still work.

Multiple Listen directives may be used to specify a number of addresses and ports to listen to. The server will respond to requests from any of the listed addresses and ports.

For example, to make the server accept connections on both port 80 and port 8000, use:

       Listen 80
       Listen 8000

To make the server accept connections on two specified interfaces and port numbers, use

       Listen 192.170.2.1:80
       Listen 192.170.2.5:8000

See Also: DNS Issues
See Also: Setting which addresses and ports Apache uses
See Also: Known Bugs

## ListenBacklog directive

Syntax: ListenBacklog backlog
Default: `ListenBacklog 511`
Context: server config
Status: MPM
Module: threaded, perchild, prefork, mpm_winnt

The maximum length of the queue of pending connections. Generally no tuning is needed or desired, however on some systems it is desirable to increase this when under a TCP SYN flood attack. See the backlog parameter to the `listen(2)` system call.

This will often be limited to a smaller number by the operating system. This varies from OS to OS. Also note that many OSes do not use exactly what is specified as the backlog, but use a number based on (but normally larger than) what is set.

## LockFile directive

Syntax: LockFile filename
Default: `LockFile logs/accept.lock`
Context: server config
Status: MPM
Module: threaded, perchild, prefork

The LockFile directive sets the path to the lockfile used when Apache is compiled with either USE_FCNTL_SERIALIZED_ACCEPT or USE_FLOCK_SERIALIZED_ACCEPT. This directive should normally be left at its default value. The main reason for changing it is if the `logs` directory is NFS mounted, since the lockfile must be stored on a local disk. The PID of the main server process is automatically appended to the filename.

SECURITY: It is best to avoid putting this file in a world writable directory such as `/var/tmp` because someone could create a denial of service attack and prevent the server from starting by creating a lockfile with the same name as the one the server will try to create.

## MaxClients directive

Syntax: MaxClients number
Default: `MaxClients 8` (with threads) `MaxClients 256` (no threads)
Context: server config
Status: MPM
Module: threaded, prefork

The MaxClients directive sets the limit on the number of child processes that will be created to serve requests. When the server is built without threading, no more than this number of clients can be served simultaneously. To configure more than 256 clients, you must edit the `HARD_SERVER_LIMIT` entry in `mpm_default.h` and recompile.

Any connection attempts over the MaxClients limit will normally be queued, up to a number based on the ListenBacklog directive. Once a child process is freed at the end of a different request, the connection will then be serviced.

When the server is compiled with threading, then the maximum number of simultaneous requests that can be served is obtained from the value of this directive multiplied by ThreadsPerChild.

## MaxRequestsPerChild directive

Syntax: MaxRequestsPerChild number
Default: `MaxRequestsPerChild 10000`
Context: server config
Status: MPM
Module: threaded, prefork, perchild, mpm_winnt

The MaxRequestsPerChild directive sets the limit on the number of requests that an individual child server process will handle. After MaxRequestsPerChild requests, the child process will die. If MaxRequestsPerChild is 0, then the process will never expire.

Setting MaxRequestsPerChild to a non-zero limit has two beneficial effects:

- it limits the amount of memory that process can consume by (accidental) memory leakage;
- by giving processes a finite lifetime, it helps reduce the number of processes when the server load reduces.

NOTE: For KeepAlive requests, only the first request is counted towards this limit. In effect, it changes the behavior to limit the number of connections per child.

## MaxSpareThreads directive

Syntax: MaxSpareThreads number
Default: `MaxSpareThreads 10 (Perchild) or 500 (threaded)`
Context: server config
Status: core
Module: threaded, perchild

Maximum number of idle threads. Different MPMs deal with this directive differently. Perchild monitor the number of idle threads on a per-child basis. If there are too many idle threads in that child, the server will begin to kill threads within that child.

threaded deals with idle threads on a server-wide basis. If there are too many idle threads in the server then child processes are killed until the number of idle threads is less than this number.

See also MinSpareThreads and StartServers.

## MaxThreadsPerChild directive

Syntax: MaxThreadsPerChild number
Default: `MaxThreadsPerChild 64` Context: server config
Status: core
Module: threaded, perchild

Maximum number of threads per child. For MPMs with a variable number of threads per child, this directive sets the maximum number of threads that will be created in each child process. To increase this value beyond its default, it is necessary to change the value of the compile-time define `HARD_THREAD_LIMIT` and recompile the server.

## MinSpareThreads directive

Syntax: MinSpareServers number
Default: `MaxSpareThreads 5 (Perchild) or 250 (threaded)`
Context: server config
Status: core
Module: threaded, perchild

Minimum number of idle threads to handle request spikes. Different MPMs deal with this directive differently. Perchild monitor the number of idle threads on a per-child basis. If there aren't enough idle threads in that child, the server will begin to create new threads within that child.

threaded deals with idle threads on a server-wide basis. If there aren't enough idle threads in the server then child processes are created until the number of idle threads is greater than number.

See also MaxSpareThreads and StartServers.

## NumServers directive

Syntax: NumServers number
Default: `NumServers 2`
Context: server config
Status: MPM
Module: perchild

Number of children alive at the same time. MPMs that use this directive do not dynamically create new child processes so this number should be large enough to handle the requests for the entire site.

## ScoreBoardFile directive

Syntax: ScoreBoardFile filename
Default: `ScoreBoardFile logs/apache_status`
Context: server config
Status: MPM
Module: threaded, perchild, prefork

The ScoreBoardFile directive is required on some architectures to place a file that the server will use to communicate between its children and the parent. The easiest way to find out if your architecture requires a scoreboard file is to run Apache and see if it creates the file named by the directive. If your architecture requires it then you must ensure that this file is not used at the same time by more than one invocation of Apache.

If you have to use a ScoreBoardFile then you may see improved speed by placing it on a RAM disk. But be careful that you heed the same warnings about log file placement and security.

See Also: Stopping and Restarting Apache

## SendBufferSize directive

Syntax: SendBufferSize bytes
Context: server config
Status: MPM
Module: threaded, perchild, prefork, mpm_winnt

The server will set the TCP buffer size to the number of bytes specified. Very useful to increase past standard OS defaults on high speed high latency (i.e., 100ms or so, such as transcontinental fast pipes)

## StartServers directive

Syntax: StartServers number
Default: `StartServers 5`
Context: server config
Status: MPM
Module: threaded, prefork

The StartServers directive sets the number of child server processes created on startup. As the number of processes is dynamically controlled depending on the load, there is usually little reason to adjust this parameter.

See also MinSpareThreads and MaxSpareThreads.

## StartThreads directive

Syntax: StartThreads number
Default: `StartThreads 5`
Context: server config
Status: MPM
Module: perchild

Number of threads each child creates on startup. As the number of threads is dynamically controlled depending on the load, there is usually little reason to adjust this parameter.

## ThreadsPerChild

Syntax: ThreadsPerChild number
Default: `ThreadsPerChild 50`
Context: server config
Status: MPM
Module: threaded, mpm_winnt

This directive sets the number of threads created by each child process. The child creates these threads at startup and never creates more. if using an MPM like mpmt_winnt, where there is only one child process, this number should be high enough to handle the entire load of the server. If using an MPM like threaded, where there are multiple child processes, the total number of threads should be high enough to handle the common load on the server.

## User directive

Syntax: User unix-userid
Default: `User #-1`
Context: server config, virtual host
Status: core
Module: threaded, perchild, prefork

The User directive sets the userid as which the server will answer requests. In order to use this directive, the standalone server must be run initially as root. Unix-userid is one of:

A username
  Refers to the given user by name.
# followed by a user number.
  Refers to a user by their number.

The user should have no privileges which result in it being able to access files which are not intended to be visible to the outside world, and similarly, the user should not be able to execute code which is not meant for httpd requests. It is recommended that you set up a new user and group specifically for running the server. Some admins use user `nobody`, but this is not always possible or desirable. For example mod_proxy's cache, when enabled, must be accessible to this user (see mod_proxy's `CacheRoot` directive).

Notes: If you start the server as a non-root user, it will fail to change to the lesser privileged user, and will instead continue to run as that original user. If you do start the server as root, then it is normal for the parent process to remain running as root.

Special note: Use of this directive in <VirtualHost> requires a properly configured suEXEC wrapper. When used inside a <VirtualHost> in this manner, only the user that CGIs are run as is affected. Non-CGI requests are still processed with the user specified in the main User directive.

SECURITY: Don't set User (or Group) to `root` unless you know exactly what you are doing, and what the dangers are.